;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;* HOD_PGM.ASM  v. 1.0  (c) 10/1999 CHD                          CZ=ANSI *
;* Hardware 24/99 CHD                                                    *
;* List 1 : zdrojov text programu pro Cross-Assembler ASM51 MetaLink    *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
$INCLUDE (HOD_DOC.ASM)
$MOD2051
$NOPAGING
$PAGEWIDTH(110)
;==========================================================================
;Pipojen port uP 89C2051 :
;P1.x - katody segmentovek
;P3.0 - anoda 0 (MSB)
;P3.1 - anoda 1
;P3.2 - anoda 2
;P3.3 - anoda 3 (LSB)
;P3.4 - tlatko SET
;P3.5 - tlatko VALUE
;P3.7 - tlatko BRIGHT
;==========================================================================
;Konstanty
;--------------------------------------------------------------------------
XRATE0 EQU  160 ;plat pro krystal 12 MHz, pro 6 MHz volit #208
XRATE1 EQU  6   ;plat pro krystal 12 MHz, pro 6 MHz volit #131
CHR_C  EQU  109 ;kd pro zobrazen znaku "c"
CHR_T  EQU  105 ;kd pro zobrazen znaku "t"
CHR_X  EQU  223 ;kd pro zobrazen pomlky
CHR_Y  EQU  191 ;kd pro zobrazen teky
;==========================================================================
;Promnn - RAM 00h a 1Fh
;--------------------------------------------------------------------------
DIHOUH DATA 01h ;pam 1. segmentu displeje / destky hodin (BCD nibble)
DIHOUL DATA 02h ;pam 2. segmentu displeje / jednotky hodin (BCD nibble)
DIMINH DATA 04h ;pam 3. segmentu displeje / destky minut (BCD nibble)
DIMINL DATA 08h ;pam 4. segmentu displeje / jednotky minut (BCD nibble)
CNT1   DATA 00h ;ta intervalu 50 ms (T1)
CNT2   DATA 03h ;ta intervalu 0,5 s (T1)
CNT3   DATA 05h ;ta intervalu 960 us (T0)
CNT4   DATA 06h ;ta intervalu 100,8 ms (T0)
CNT5   DATA 07h ;ta intervalu 504 ms (T0)
CNT7   DATA 09h ;ta intervalu 20 s (T0)
SEC    DATA 0Ah ;registr aktulnch vtein (BCD byte)
MIN    DATA 0Bh ;registr aktulnch minut (BCD byte)
HOU    DATA 0Ch ;registr aktulnch hodin (BCD byte)
VALUE  DATA 0Dh ;promnn pro inkrementaci
VALMA  DATA 0Eh ;maximum+1 pro inkrementaci
VALMI  DATA 0Fh ;minimum pro inkrementaci
CNTVAL DATA 10h ;prodleva plynul inkrementace 0,5 s
DIRBRT DATA 11h ;pointer jasu
DIRVIE DATA 12h ;pointer typu zobrazen
AUX    EQU  R0  ;[00h] pomocn reg. pro nulovn RAM
ANODY  EQU  R1  ;[19h] pointer anod (pozice displeje) [# = 1/2/4/8]
DIRSET EQU  R2  ;[1Ah] pointer funkce SET
CNT6   EQU  R3  ;[1Bh] ta interval 20 s alternativnho zobrazen (T0)
;==========================================================================
;Bitov nvt - RAM 20h a 21h
;--------------------------------------------------------------------------
HALF   BIT  00h  ;stav des. teky : 0 = nesvt / 1 = svt
FLASH  BIT  01h  ;nvt blikn : 0 = zhasnout / 1 = rozsvtit
CYKL   BIT  02h  ;cykl tn : 0 = 24 hod / 1 = 12 hod
VIEWT  BIT  03h  ;typ zobrazen : 0 = hod+min / 1 = min+sec
FLVAL  BIT  04h  ;povolen inkrementace
WTVAL  BIT  05h  ;aktivn prodleva ped plynulou inkrementac
GOVAL  BIT  06h  ;povolen plynul inkrementace
BUTTON DATA 21h  ;banka buffer tlatek
BUFSET BIT  0Ch  ;buffer tlatka SET
BUFVAL BIT  0Dh  ;buffer tlatka VALUE
BUFBRT BIT  0Fh  ;buffer tlatka BRIGHT
;**************************************************************************
;Vektory peruen
;==========================================================================
           ORG   0000h
           AJMP  init
           ORG   000Bh
           AJMP  tim0
           ORG   001Bh
           AJMP  tim1
;**************************************************************************
;Inicializace
;==========================================================================
           ORG   0030h
init:      MOV   AUX, #07Fh       ;nulovn RAM
ini_memo:  MOV   @AUX, #00h
           DJNZ  AUX, ini_memo
           MOV   SP, #5Fh         ;hloubka zsobnku 32 byte
           MOV   PSW, #18h        ;banka registr 3
;==========================================================================
;Nastaven asov zkladny a SFR
;--------------------------------------------------------------------------
           MOV   CNT3, #16
           MOV   CNT4, #105
           MOV   CNT5, #2
           MOV   ANODY, #1
           MOV   DIRBRT, #4
           MOV   DIRVIE, #3
           ;---------------------- SFR
           MOV   DPTR, #tab_dat
           MOV   TH0, #XRATE0     ;T0 peteen po 96 us
           MOV   TL0, #XRATE0
           MOV   TMOD, #22h       ;oba tae v mdu 2
           MOV   TCON, #10h       ;ta 0 sputn
           MOV   IE, #8Ah         ;povoleno ET0, ET1
           AJMP  f_set
;**************************************************************************
;Hlavn programov smyka - normln bh hodin
;==========================================================================
main:      ACALL vw_run
           MOV   A, BUTTON
           JNZ   main             ;ekej na putn vech tlatkek
main1:     JNB   BUFSET, view     ;je stisknuto SET ?
           AJMP  f_set            ;ano -> na reim nastavovn
view:      JNB   BUFVAL, bright   ;je stisknuto VALUE ?
           AJMP  f_view           ;ano -> na zmnu zobrazen
bright:    JNB   BUFBRT, display  ;je stisknuto BRIGHT ?
           AJMP  f_bright         ;ano -> na zmnu jasu
display:   ACALL vw_run           ;data pro zobrazen
           SJMP  main1
;==========================================================================
;Reim nastavovn
;--------------------------------------------------------------------------
f_set:     MOV   CNT6, #0         ;zruit alternativn zobrazen
           MOV   CNT7, #210
           CLR   VIEWT
           ;--------------------- Inicializace tae 1
           CLR   TR1              ;zastavit ta 1
           MOV   TL1, #XRATE1     ;peteen po 250 us
           MOV   TH1, #XRATE1
           MOV   CNT1, #200       ;interval 50 ms
           MOV   CNT2, #10        ;interval 0,5 s
           SETB  HALF
           MOV   SEC, #0          ;nulovat registr vtein
           PUSH  DIRBRT           ;uloit aktuln jas
           MOV   DIRBRT, #9       ;nastavit max. jas
           MOV   DIRSET, #0       ;prvn krok pro SET 
f_set0:    ACALL vw_set
           MOV   A, BUTTON
           JNZ   f_set0           ;ekej na putn vech tlatkek
f_set1:    ACALL vw_set
           JNB   BUFSET, f_set2
           CJNE  DIRSET, #3, f_s10
           POP   DIRBRT           ;zpt na normaln bh
           SETB  TR1
           AJMP  main
f_s10:     CJNE  DIRSET, #0, f_s11
           JNB   CYKL, f_s11
           MOV   A, HOU           ;pevod 24->12
           MOV   DPTR, #tab_con
           MOVC  A, @A+DPTR
           MOV   HOU, A
           MOV   DPTR, #tab_dat
f_s11:     INC   DIRSET           ;dal krok SET
           SJMP  f_set0
           ;--------------------- Zmna cyklu
f_set2:    JNB   BUFVAL, f_set1
           CJNE  DIRSET, #0, f_s21
           CPL   CYKL
           AJMP  f_set0
           ;--------------------- Zmna doby alternativnho zobrazen
f_s21:     CJNE  DIRSET, #1, f_s22
           MOV   VALUE, DIRVIE
           MOV   VALMA, #10h
           MOV   VALMI, #00h
           SETB  FLVAL
f_s210:    MOV   DIRVIE, VALUE
           ACALL vw_set
           JB    BUFVAL, f_s210   ;VALUE stle stisknuto ?
           CLR   FLVAL
           AJMP  f_set0
           ;--------------------- Zmna hodin
f_s22:     CJNE  DIRSET, #2, f_s23
           MOV   VALUE, HOU
           JB    CYKL, f_s220     ;nastaven mez dle zvolenho cyklu
           MOV   VALMA, #24h
           MOV   VALMI, #00h
           SJMP  f_s221
f_s220:    MOV   VALMA, #13h
           MOV   VALMI, #01h
f_s221:    SETB  FLVAL
f_s222:    MOV   HOU, VALUE
           ACALL vw_set
           JB    BUFVAL, f_s222   ;VALUE stle stisknuto ?
           CLR   FLVAL
           AJMP  f_set0
           ;--------------------- Zmna minut
f_s23:     MOV   VALUE, MIN
           MOV   VALMA, #60h
           MOV   VALMI, #00h
           SETB  FLVAL
f_s230:    MOV   MIN, VALUE
           ACALL vw_set
           JB    BUFVAL, f_s230   ;VALUE stle stisknuto ?
           CLR   FLVAL
           AJMP  f_set0
;==========================================================================
;Zpsob zobrazen - normln / alternativn
;--------------------------------------------------------------------------
f_view:    CPL   VIEWT
           JNB   VIEWT, f_view1
           MOV   CNT6, DIRVIE     ;alternativn
           AJMP  main
f_view1:   MOV   CNT6, #0         ;normln
           MOV   CNT7, #210
           AJMP  main
;==========================================================================
;Zmna jasu
;--------------------------------------------------------------------------
f_bright:  MOV   A, DIRBRT
           INC   A
           CJNE  A, #10, f_b1
           CLR   A
f_b1:      MOV   DPTR, #tab_brt   ;piblin linern aproximace
           MOVC  A, @A+DPTR
           MOV   DIRBRT, A
           MOV   DPTR, #tab_dat
           AJMP  main
;**************************************************************************
;Procedury zobrazen - penos aktulnch dat do pamt segment displeje
;==========================================================================
;Normln bh hodin
;--------------------------------------------------------------------------
vw_run:    ;--------------------- Displej vypnut (nulov jas)
           MOV   A, DIRBRT
           JNZ   vw_run0
           MOV   DIHOUH, #0FFh    ;przdn
           MOV   DIMINH, #0FFh    ;przdn
           MOV   DIMINL, #0FFh    ;przdn
           CPL   A
           JNB   HALF, vw_r00
           ANL   A, #CHR_Y        ;pidat teku
vw_r00:    MOV   DIHOUL, A
           RET
           ;--------------------- Standardn zobrazen (hod + min)
vw_run0:   JB    VIEWT, vw_run1
           MOV   A, HOU
           SWAP  A
           ANL   A, #0Fh
           JNZ   vw_r01           ;potlaen nevznamn nuly
           MOV   DIHOUH, #0FFh    ;przdn
           SJMP  vw_r02
vw_r01:    MOVC  A, @A+DPTR
           MOV   DIHOUH, A
vw_r02:    MOV   A, HOU
           ANL   A, #0Fh
           MOVC  A, @A+DPTR
           JNB   HALF, no_dp
           ANL   A, #CHR_Y        ;pidat teku
no_dp:     MOV   DIHOUL, A
           MOV   A, MIN
           SWAP  A
           ANL   A, #0Fh
           MOVC  A, @A+DPTR
           MOV   DIMINH, A
           MOV   A, MIN
           ANL   A, #0Fh
           MOVC  A, @A+DPTR
           MOV   DIMINL, A
           RET
           ;--------------------- Alternativn zobrazen (min + sec)
vw_run1:   MOV   A, MIN
           SWAP  A
           ANL   A, #0Fh
           MOVC  A, @A+DPTR
           MOV   DIHOUH, A
           MOV   A, MIN
           ANL   A, #0Fh
           MOVC  A, @A+DPTR
           JNB   HALF, no_dp1
           ANL   A, #CHR_Y        ;pidat teku
no_dp1:    MOV   DIHOUL, A
           MOV   A, SEC
           SWAP  A
           ANL   A, #0Fh
           MOVC  A, @A+DPTR
           MOV   DIMINH, A
           MOV   A, SEC
           ANL   A, #0Fh
           MOVC  A, @A+DPTR
           MOV   DIMINL, A
           RET
;==========================================================================
;Reim nastavovn
;--------------------------------------------------------------------------
vw_set:    ;--------------------- Cykl
           CJNE  DIRSET, #0, vw_set1
           MOV   DIHOUH, #CHR_C   ;znak "c"
           MOV   DIHOUL, #CHR_X   ;pomlka
           JB    FLASH, vw_s00
           MOV   DIMINH, #0FFh    ;przdn
           MOV   DIMINL, #0FFh    ;przdn
           RET
vw_s00:    JB    CYKL, vw_s01
           MOV   DIMINH, #064h    ;"2"
           MOV   DIMINL, #0C3h    ;"4"
           RET
vw_s01:    MOV   DIMINH, #0D7h    ;"1"
           MOV   DIMINL, #064h    ;"2"
           RET
           ;--------------------- Doba alternativnho zobrazen
vw_set1:   CJNE  DIRSET, #1, vw_set2
           MOV   DIHOUH, #CHR_T   ;znak "t"
           MOV   DIHOUL, #CHR_X   ;pomlka
           MOV   DIMINH, #0FFh    ;przdn
           JB    FLASH, vw_s10
           MOV   DIMINL, #0FFh    ;przdn
           RET
vw_s10:    MOV   A, DIRVIE
           ANL   A, #0Fh
           MOVC  A, @A+DPTR
           MOV   DIMINL, A
           RET
           ;--------------------- Hodiny
vw_set2:   CJNE  DIRSET, #2, vw_set3
           JB    FLASH, vw_s20
           MOV   DIHOUH, #0FFh    ;przdn
           MOV   DIHOUL, #CHR_Y   ;teka
           SJMP  vw_s21
vw_s20:    MOV   A, HOU
           SWAP  A
           ANL   A, #0Fh
           JNZ   vw_s23
           MOV   DIHOUH, #0FFh    ;przdn
           SJMP  vw_s22
vw_s23:    MOVC  A, @A+DPTR
           MOV   DIHOUH, A
vw_s22:    MOV   A, HOU
           ANL   A, #0Fh
           MOVC  A, @A+DPTR
           ANL   A, #CHR_Y        ;pidat teku
           MOV   DIHOUL, A
vw_s21:    MOV   A, MIN
           SWAP  A
           ANL   A, #0Fh
           MOVC  A, @A+DPTR
           MOV   DIMINH, A
           MOV   A, MIN
           ANL   A, #0Fh
           MOVC  A, @A+DPTR
           MOV   DIMINL, A
           RET
           ;--------------------- Minuty
vw_set3:   MOV   A, HOU
           SWAP  A
           ANL   A, #0Fh
           JNZ   vw_s32
           MOV   DIHOUH, #0FFh    ;przdn
           SJMP  vw_s31
vw_s32:    MOVC  A, @A+DPTR
           MOV   DIHOUH, A
vw_s31:    MOV   A, HOU
           ANL   A, #0Fh
           MOVC  A, @A+DPTR
           ANL   A, #CHR_Y        ;pidat teku
           MOV   DIHOUL, A
           JB    FLASH, vw_s30
           MOV   DIMINH, #0FFh    ;przdn
           MOV   DIMINL, #0FFh    ;przdn
           RET
vw_s30:    MOV   A, MIN
           SWAP  A
           ANL   A, #0Fh
           MOVC  A, @A+DPTR
           MOV   DIMINH, A
           MOV   A, MIN
           ANL   A, #0Fh
           MOVC  A, @A+DPTR
           MOV   DIMINL, A
           RET
;**************************************************************************
;Obsluha peruen od CT0 (po 96 us) - asov zkladna
;==========================================================================
tim0:      PUSH  ACC
           PUSH  PSW
           ;--------------------- zen jasu displeje
           MOV   A, DIRBRT
           CJNE  A, #0, run_a     ;displej vypnut ?
           CJNE  A, CNT3, run_a
           ORL   P3, #0Fh
run_a:     INC   CNT3
           MOV   A, CNT3
           CJNE  A, DIRBRT, skip_a
           ORL   P3, #0Fh         ;vypnout vechny anody
skip_a:    CJNE  A, #10, etim0
           MOV   CNT3, #0         ;interval 960 us
           ;--------------------- Displej + tlatka
           MOV   A, ANODY         ;posun pointeru anody
           RL    A
           CJNE  A, #10h, next_a
           SWAP  A
           PUSH  ACC
           MOV   A, P3            ;naten tlatek (po 3,84 ms)
           CPL   A
           ANL   A, #0B0h         ;pouze bity .4, .5, .7
           MOV   BUTTON, A
           POP   ACC
next_a:    MOV   ANODY, A
           MOV   P1, @ANODY       ;data z pamti displeje na katody
           CPL   A                ;aktuln anodu zapnout
           ANL   P3, A
           ;--------------------- Inkrementace pro funkci SET
           DJNZ  CNT4, etim0
           MOV   CNT4, #105       ;interval 100,8 ms
           JB    FLVAL, go_inc    ;inkrementace sputna ?
           CLR   GOVAL            ;konec inkrementace
           SJMP  end_inc
go_inc:    JB    WTVAL, cyc_inc   ;ekat ped plynulou inkrementac ?
           MOV   A, VALUE         ;inkrementace promnn VALUE v BCD
           ADD   A, #1            ; kdu v rozsahu od VALMI do VALMA-1
           DA    A
           MOV   VALUE, A
           CJNE  A, VALMA, go1_inc
           MOV   VALUE, VALMI
go1_inc:   JB    GOVAL, chng_fl
           SETB  WTVAL            ;pouze pi prvnm prchodu
cyc_inc:   JNB   WTVAL, esc_inc
           DJNZ  CNTVAL, chng_fl
esc_inc:   SETB  GOVAL            ;konec prodlevy ped plynulou inkrem.
end_inc:   CLR   WTVAL
           MOV   CNTVAL, #6       ;prodleva cca 0,5 s
           ;--------------------- Blikn displeje
chng_fl:   DJNZ  CNT5, wait_vw
           CPL   FLASH
           MOV   CNT5, #2         ;perioda 504 ms, stda 60%
           JNB   FLASH, wait_vw
           INC   CNT5
           ;--------------------- Doba trvn alternativnho zobrazen
wait_vw:   CJNE  CNT6, #00, wait_vw1
           SJMP  etim0            ;alt. zobrazen vypnuto
wait_vw1:  DJNZ  CNT7, etim0      ;odpoet [t] x 20 s
           MOV   CNT7, #210
           DJNZ  CNT6, etim0
           CLR   VIEWT            ;doba uplynula, vypnout
           ;--------------------- Konec obsluhy peruen
etim0:     POP   PSW
           POP   ACC
           RETI
;**************************************************************************
;Obsluha peruen od CT1 (po 250 us) - bh hodin
;==========================================================================
tim1:      DJNZ  CNT1, endtim1
           MOV   CNT1, #200       ;interval 50 ms
           DJNZ  CNT2, endtim1
           MOV   CNT2, #10        ;interval 0,5 s
           CPL   HALF             ;zmna stavu des. teky
           JNB   HALF, endtim1
           PUSH  ACC              ;interval 1 s
           PUSH  PSW
           MOV   A, SEC           ;inkrementace vtein
           ADD   A, #1
           DA    A
           MOV   SEC, A
           CJNE  A, #60h, etim1
           MOV   SEC, #0
           MOV   A, MIN           ;inkrementace minut
           ADD   A, #1
           DA    A
           MOV   MIN, A
           CJNE  A, #60h, etim1
           MOV   MIN, #0
           MOV   A, HOU           ;inkrementace hodin
           ADD   A, #1
           DA    A
           MOV   HOU, A
           JB    CYKL, cykl12
           CJNE  A, #24h, etim1   ;cykl 24 hod
           MOV   HOU, #0
           SJMP  etim1
cykl12:    CJNE  A, #13h, etim1   ;cykl 12 hod
           MOV   HOU, #1
etim1:     POP   PSW
           POP   ACC
endtim1:   RETI
;**************************************************************************
;Tabulky dat
;==========================================================================
;Kdy pro katody segmentovek
; Piazen segment jednotlivm bitm P1 (0 = svt, 1 = nesvt) :
; a=P1.0, d=P1.1, f=P1.2, b=P1.3, g=P1.4, c=P1.5, h=P1.6, e=P1.7 
;--------------------------------------------------------------------------
tab_dat:   ;     0    1    2    3    4    5    6    7    8    9    spc
           DB    050h,0D7h,064h,0C4h,0C3h,0C8h,048h,0D6h,040h,0C0h,0FFh
;==========================================================================
;Konverze cyklu 24 -> 12
;--------------------------------------------------------------------------
tab_con:   DB    012h,001h,002h,003h,004h,005h,006h,007h  ;data 00h a 24h
           DB    008h,009h,000h,000h,000h,000h,000h,000h
           DB    010h,011h,012h,001h,002h,003h,004h,005h
           DB    006h,007h,000h,000h,000h,000h,000h,000h
           DB    008h,009h,010h,011h
;==========================================================================
;Linearizace jasu
;--------------------------------------------------------------------------
tab_brt:   DB    000h,001h,002h,003h,004h,005h,007h,000h  ;stupe 0 a 7
           DB    009h,000h
;==========================================================================
           DB    '"HOD_PGM.ASM REV.1.0 (c) 1999 J.DAVID '
           DB    '- USE FOR NON-PROFIT APPLICATION ONLY"'
;**************************************************************************
           END